Graphics 16*32,16*32,8,2
SetBuffer BackBuffer()
AppTitle"TANKTICS BY DAVID"

splash=LoadImage("splash.bmp")
Color 255,255,0
Repeat
Cls
DrawImage splash,0,0
Text 256,250,"PRESS 'P' TO PLAY",1
Flip
Until KeyDown(25)
FlushKeys()
FreeImage splash

SeedRnd MilliSecs()
Global tiles=LoadAnimImage("tiles.bmp",16,16,0,9)
Global tank=LoadAnimImage("tanks.bmp",16,16,0,19)
MaskImage tank,255,0,255
Global map=CreateImage(16*32,16*32)
SetBuffer ImageBuffer(map)
Dim grid(31,31)
level=Rand(1,11)
file=OpenFile("levels\Level_"+level+".tnk")
For x=0 To 31
For y=0 To 31
grid(x,y)=ReadByte(file)
DrawImage tiles,x*16,y*16,grid(x,y)
Next
Next
CloseFile file
SetBuffer BackBuffer()

Type tank
Field x#,y#,clr,hp,dir,go,ai,change,aix,aiy,fire
End Type
Type bullet
Field x,y,dir,time
End Type

Global alive=1
Const red=1,green=2,blue=3,yellow=4
Const N=0,E=1,S=2,W=3
Const north=0,east=1,south=2,west=3,point=4,still=5

For do=1 To 4
t.tank=New tank
If do=1 Then t\x=0:t\y=0 Else If do=2 t\x=31:t\y=0 Else If do=3 Then t\x=31:t\y=31 Else If do=4 t\x=0:t\y=31
t\hp=6
t\clr=(do-1)*4
frame=do+1
If frame=5 Then frame=1
t\dir=(frame-1)
Next


Repeat
alive=0
ais=0
Cls

DrawImage map,0,0


For b.bullet=Each bullet
die=0
b\time=b\time+1
Color 0,0,0
Oval b\x-2,b\y-2,4,4
Select b\dir
Case n:b\y=b\y-10
Case e:b\x=b\x+10
Case s:b\y=b\y+10
Case w:b\x=b\x-10
End Select
For t.tank=Each tank
If RectsOverlap(t\x*16,t\y*16,16,16,b\x,b\y,4,4) Then t\hp=t\hp-1:die=1
Next
If b\time>=16 Then
die=1
EndIf
If die=1 Then Delete b
Next


For t.tank=Each tank

If t\hp=<0 Then Delete t:Exit

If t\x<0 Then t\x=0 Else If t\x>31 Then t\x=31
If t\y<0 Then t\y=0 Else If t\y>31 Then t\y=31
lastx=t\x:lasty=t\y

DrawImage tank,t\x*16,t\y*16,t\clr+t\dir
Color 0,0,0
Rect t\x*16-4,t\y*16-4,6*4,2
Color 0,255,0
Rect t\x*16-4,t\y*16-4,t\hp*4,2

If t\clr=0 Then

If t\fire=0 Then
If KeyDown(57) Then 
Select t\dir
Case n:bullet(t\x*16+8,t\y*16+8-20,t\dir):t\fire=30
Case s:bullet(t\x*16+8,t\y*16+8+20,t\dir):t\fire=30
Case e:bullet(t\x*16+8+20,t\y*16+8,t\dir):t\fire=30
Case w:bullet(t\x*16+8-20,t\y*16+8,t\dir):t\fire=30
End Select
EndIf
Else
t\fire=t\fire-1
EndIf

alive=1

If t\go=0 Then
If KeyDown(200) Then t\y=t\y-1:t\dir=n Else If KeyDown(208) Then t\y=t\y+1:t\dir=s Else If KeyDown(203) Then t\x=t\x-1:t\dir=w Else If KeyDown(205) Then t\x=t\x+1:t\dir=e
If t\x<0 Then t\x=0 Else If t\x>31 Then t\x=31
If t\y<0 Then t\y=0 Else If t\y>31 Then t\y=31
If grid(t\x,t\y)=5 Then t\x=lastx:t\y=lasty
If grid(t\x,t\y)=0 Then t\go=10
If grid(t\x,t\y)=1 Then t\go=15
If grid(t\x,t\y)=2 Then t\go=20
If grid(t\x,t\y)=3 Then t\go=25
If grid(t\x,t\y)=4 Then t\go=30
Else
t\go=t\go-1
EndIf

Else

If t\fire=0 Then
Select t\dir
Case n:bullet(t\x*16+8,t\y*16+8-20,t\dir):t\fire=Rand(20,120)
Case s:bullet(t\x*16+8,t\y*16+8+20,t\dir):t\fire=Rand(20,120)
Case e:bullet(t\x*16+8+20,t\y*16+8,t\dir):t\fire=Rand(20,120)
Case w:bullet(t\x*16+8-20,t\y*16+8,t\dir):t\fire=Rand(20,120)
End Select
Else
t\fire=t\fire-1
EndIf

t\change=t\change-1
If t\change<=0 Then t\ai=Rand(0,5):t\change=Rand(60,180):If t\ai=4 Then t\aix=Rand(0,31):t\aiy=Rand(0,31)

If t\go=0 Then
Select t\ai
Case 0:t\y=t\y-1:t\dir=n
Case 1:t\x=t\x+1:t\dir=e
Case 2:t\y=t\y+1:t\dir=s
Case 3:t\x=t\x-1:t\dir=w
Case 4:If t\x>t\aix Then t\x=t\x-1:t\dir=w Else If t\x<t\aix Then t\x=t\x+1:t\dir=e Else If t\y>t\aiy Then t\y=t\y-1:t\dir=n Else If t\y<t\aiy Then t\y=t\y+1:t\dir=s
Case 5:t\x=t\x:t\y=t\y
End Select
If t\x<0 Then t\x=0 Else If t\x>31 Then t\x=31
If t\y<0 Then t\y=0 Else If t\y>31 Then t\y=31
If grid(t\x,t\y)=5 Then t\x=lastx:t\y=lasty
If grid(t\x,t\y)=0 Then t\go=10
If grid(t\x,t\y)=1 Then t\go=15
If grid(t\x,t\y)=2 Then t\go=20
If grid(t\x,t\y)=3 Then t\go=25
If grid(t\x,t\y)=4 Then t\go=30
Else
t\go=t\go-1
EndIf

EndIf

Next

If alive=0 Then
Cls
Repeat
Cls
Color 255,255,0
Text 256,256,"GAME OVER",1,1
Flip
If KeyDown(1) Then End
Forever
EndIf

For t.tank=Each tank
If t\clr>0 Then ais=ais+1
Next

If ais=0 Then
Cls
Repeat
Cls
Color 255,255,0
Text 256,256,"CONGRATULATIONS; YOU WIN!",1,1
Flip
If KeyDown(1) Then End
Forever
EndIf

Flip
Until KeyDown(1)
End




Function bullet(x,y,dir)
b.bullet=New bullet
b\x=x:b\y=y:b\dir=dir
End Function